<?php
// Initialize as pre authentication plugin
plugin_add_hook('PRE_AUTHENTICATE', 'plugin_openid_auth');

// Authenticate users by openid provider
function plugin_openid_auth()
{
    if((include_once $GLOBALS['PLUGIN_PATH'].'/openid/openid.ini') === false) {
        echo 'ERROR: Please configure the Openid plugin from the Plugin Manager Control panel.';
        return 0;
    }

    require_once $GLOBALS['PLUGIN_PATH'] . '/openid/lib/class.dopeopenid.php';
    $openid = new Dope_OpenID($ini['OPENID_PROVIDER']);

    // first entry
    if (empty($_REQUEST['verify'])) {

        // set return & root urls
        $openid->setReturnURL($ini['OPENID_RETURN_URL']);
        $openid->SetTrustRoot($ini['OPENID_TRUST_URL']);

        // ask openid provider to return user's email
        // could be 'nickname', 'fullname', 'country', 'language'
        $openid->setOptionalInfo(array('email'));

        // get openid provider metainformation
        if ($openid->getOpenIDEndpoint()) {

            //redirect to openid provider
            $openid->redirect();
            exit(0);
        }
    } else {

        // second entry: openid provider has returned auth params
        if (empty($_REQUEST['openid_mode']) || $_REQUEST['openid_mode'] != 'cancel') {

            // check auth token
            if ($openid->validateWithServer($_REQUEST) === TRUE) {

                // get passed user's params
                $params = $openid->filterUserInfo($_REQUEST);
                if (!empty($params['email'])) {

                    // attention: just only google returns email
                    // use $params['openid_identity'] instead
                    if ($id = get_id_by_email($params['email']))
                        return usr_reg_get_full($id);
                }
            }
        }
    }

    // by default return false
    return false;
}

function openid_info() {
    return array('name' => 'OpenID Authentication',
                 'desc' => 'Authenticate forum users by OpenID provider.',
                 'version' => '0.1');
}

function openid_config() {
    if((include_once $GLOBALS['PLUGIN_PATH'].'/openid/openid.ini') === false) {
        $ini = NULL;
    }

    if (isset($_POST['Set'])) {
        foreach (array_keys($_POST) as $key) {
            if (substr($key,0,4) == 'OPENID_') {
                $ini[$key] = $_POST[$key];
            }
        }
        $fp = fopen($GLOBALS['PLUGIN_PATH'].'/openid/openid.ini', 'w');
        fwrite($fp, '<?php $ini = '.var_export($ini, 1).'; ?>');
        fclose($fp);
        echo '<font color="green">Settings successfully saved.</font>';
    }
    ?>
<p>Return URL:<br />
<input name="OPENID_RETURN_URL" value="<?php echo $ini['OPENID_RETURN_URL'] ?>" /></p>

<p>Trust URL:<br />
<input name="OPENID_TRUST_URL" value="<?php echo $ini['OPENID_TRUST_URL'] ?>" /></p>

<p>OpenID provider URL:<br />
<input name="OPENID_PROVIDER" value="<?php echo $ini['OPENID_PROVIDER'] ?>" /></p>

<?php
}
